#!/usr/bin/env node
import { I as r, S as d } from "./index-a1ee6691.js";
import { log as o, _get as I, initHandlerCommon as b, getConfigFileCommonOptions as $, _set as w, readConfigFile as _, createSubcommand as A, createMainCommand as k } from "@done-coding/cli-utils";
import j from "node:path";
import m from "node:fs";
const M = ({
  sourceJson: e,
  targetKey: n,
  keyConfig: t
}) => {
  let s;
  typeof t == "string" ? s = {
    type: r.FIXED,
    value: t
  } : s = t;
  const { type: i = r.READ } = s;
  switch (i) {
    case r.REG: {
      const { sourceKey: c, pattern: f, replaceValue: p, flags: g } = s, y = new RegExp(f, g ?? void 0), a = I(e, c);
      return typeof a == "string" ? a.replace(y, p) : (o.warn(
        `${a}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
      ), a);
    }
    case r.FIXED: {
      const { value: c } = s;
      return c;
    }
    case r.READ: {
      const { sourceKey: c = n } = s;
      return I(e, c);
    }
    default: {
      o.warn(`未知的配置类型${i}`);
      return;
    }
  }
}, h = {
  name: "@done-coding/cli-inject",
  version: "0.5.10-alpha.0",
  description: "信息(JSON)注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, {
  cliConfig: { namespaceDir: x, moduleName: G }
} = h, L = `./${x}/${G}`, N = `${L}.json`, J = {
  sourceFilePath: "./package.json",
  keyConfigMap: {
    name: {
      type: r.READ
    },
    version: {
      type: r.READ
    },
    description: {
      type: r.READ
    }
  },
  injectFilePath: "./src/injectInfo.json"
}, R = J, U = () => $({
  configPathDefault: N
}), O = async (e) => b(R, e, {
  onFileGenerated: () => {
    o.info("文件生成成功");
  }
}), V = {
  command: d.INIT,
  describe: "初始化配置文件",
  options: U(),
  handler: O
}, H = () => ({
  ...$({
    configPathDefault: N
  })
}), K = async ({
  rootDir: e = process.cwd(),
  config: n = R,
  keyConfigMap: t = {}
} = {}) => {
  const {
    sourceFilePath: s,
    keyConfigMap: i,
    injectFilePath: c
  } = n, f = {
    ...i,
    ...t
  };
  if (!s.endsWith(".json"))
    return o.error("源文件必须是json"), process.exit(1);
  if (!c.endsWith(".json"))
    return o.error("注入文件必须是json"), process.exit(1);
  const p = j.resolve(e, s), g = m.readFileSync(p, "utf-8"), y = JSON.parse(g), a = Object.entries(f).reduce(
    (u, [F, P]) => {
      const T = M({ sourceJson: y, targetKey: F, keyConfig: P });
      return w(u, F, T), u;
    },
    {}
  ), l = j.resolve(e, c), E = JSON.stringify(a, null, 2);
  if (m.existsSync(l)) {
    const u = m.readFileSync(l, "utf-8");
    if (E === u)
      return o.skip("注入文件已存在且内容相同，无需重复注入"), a;
    o.stage("文件内容变化,开始覆盖注入文件");
  } else
    o.stage("开始注入文件");
  m.writeFileSync(l, E), o.success(`文件注入成功: ${l}`), o.info(E);
}, C = async (e) => {
  const n = await _(e);
  if (!n)
    return o.error("配置文件为空"), process.exit(1);
  const { rootDir: t } = e;
  await K({ rootDir: t, config: n });
}, W = {
  command: d.GENERATE,
  describe: "生成文件",
  options: H(),
  handler: C
}, Z = async (e, n) => {
  switch (e) {
    case d.INIT:
      return O(n);
    case d.GENERATE:
      return C(n);
    default:
      return C(n);
  }
}, { version: X, description: q } = h, S = {
  describe: q,
  version: X,
  subcommands: [V, W].map(
    A
  ),
  demandCommandCount: 1
}, {
  cliConfig: { moduleName: D }
} = h, v = (e = !1) => {
  const n = e ? D : void 0, t = `$0${e ? ` ${D}` : ""} <command> [options]`;
  return { command: n, usage: t };
}, ee = async () => k({
  ...S,
  ...v()
}), ne = () => A({
  ...S,
  ...v(!0)
});
export {
  ne as a,
  V as b,
  ee as c,
  C as d,
  W as e,
  Z as f,
  K as g,
  O as h,
  S as i,
  M as k
};
